﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FileOperations
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private async void button1_Click(object sender, EventArgs e)
        {
            button1.Enabled = false;
            try
            {
                using (FileStream input = new FileStream(txtFilestreamFrom.Text, FileMode.Open))
                {
                    using (FileStream output = new FileStream(txtFilestreamTo.Text, FileMode.Create))
                    {
                        await input.CopyToAsync(output);
                        await output.FlushAsync();
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), ex.Message, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            button1.Enabled = true;


        }

        private async void button2_Click(object sender, EventArgs e)
        {
            button2.Enabled = false;
            FileStream output = File.OpenWrite(txtWriteTo.Text);
            TextWriter writer = (TextWriter)new StreamWriter(output);

            var text = await BuildTextAsync();

            await writer.WriteAsync(text);

            button2.Enabled = true;


        }

        private Task<string> BuildTextAsync()
        {
            return Task.Run<string>(() =>
            {
                string content = string.Empty;
                for (int i = 0; i < 200000; i++)
                {
                    content += "lorem ipsum...";
                }
                return content;
            });
        }

        private async void button3_Click(object sender, EventArgs e)
        {
            FileStream fs = File.OpenRead(txtReadFrom.Text);
            TextReader reader = (TextReader)new StreamReader(fs);
            var text = await reader.ReadToEndAsync();
            MessageBox.Show(text);

        }

        private async void button4_Click(object sender, EventArgs e)
        {
            try
            {
                HttpClient client = new HttpClient();

                HttpResponseMessage response = await client.GetAsync(txtDownload.Text);
                response.EnsureSuccessStatusCode();
                string body = await response.Content.ReadAsStringAsync();

                MessageBox.Show(body);
                // string body = await client.GetStringAsync(uri);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), ex.Message);
            }
        }

    }
}
