﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Threading;

namespace StaticPropertyBindingSample
{
    public static class Wärmesensor
    {
        public static event EventHandler TemperaturChanged;
        private static DispatcherTimer timer;
        static Wärmesensor()
        {
            timer = new DispatcherTimer(TimeSpan.FromSeconds(3), DispatcherPriority.Normal, (s, e) => { Temperatur = new Random().Next(-100, 450) / 10; }, Dispatcher.CurrentDispatcher);
            timer.Start();
        }

        private static double _temperatur;

        public static double Temperatur
        {
            get { return _temperatur; }
            set
            {
                _temperatur = value;
                if (TemperaturChanged != null)
                {
                    TemperaturChanged(null, EventArgs.Empty);
                }
            }
        }
    }
}
