﻿using Contract;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace Client
{
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single, ConcurrencyMode = ConcurrencyMode.Multiple)]
    public class StockService : IStockService
    {
        Guid appid = Guid.NewGuid();

        public event EventHandler<Tuple<string, double>> GotStock;

        public void GetStock(string name, double value)
        {
            if (GotStock != null)
            {
                GotStock(this, new Tuple<string, double>(name, value));
            }
        }


        public string GetFastesClient()
        {
            return "Machine: " + Environment.MachineName + " AppId: " + appid.ToString();
        }
    }
}
