﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace tps_sample
{
    /// <summary>
    /// Interaction logic for ConcurrentExclusiveSchedulerPairSample.xaml
    /// </summary>
    public partial class ConcurrentExclusiveSchedulerPairSample : UserControl
    {
        private int sleepTime = 2;

        private ConcurrentExclusiveSchedulerPair _shedulerPair;
        public ObservableCollection<string> Values { get; private set; }
        private int exclusiveCounter = 0;
        private int concurrentCounter = 0;

        public ConcurrentExclusiveSchedulerPairSample()
        {
            _shedulerPair = new ConcurrentExclusiveSchedulerPair();
            Values = new ObservableCollection<string>();
            this.DataContext = this;
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Task t = new Task(() =>
            {
                Thread.Sleep(TimeSpan.FromSeconds(sleepTime));
                this.Dispatcher.Invoke(() =>
                {
                    int i = Interlocked.Increment(ref concurrentCounter);
                    Values.Insert(0, string.Format("Concurrent: {0}", i));
                });
            });
            t.Start(_shedulerPair.ConcurrentScheduler);
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            Task t = new Task(() =>
            {
                Thread.Sleep(TimeSpan.FromSeconds(sleepTime));
                this.Dispatcher.Invoke(() =>
                {
                    int i = Interlocked.Increment(ref exclusiveCounter);
                    Values.Insert(0, string.Format("Exclusive: {0}", i));
                });
            });
            t.Start(_shedulerPair.ExclusiveScheduler);
        }
    }
}
